%This Example for using users m-function Optimization_subroutine.m was created automatically by PSG Toolbox.

%Function description:

%maximize                                                     
%logexp_sum(matrix_F3)                                      
%Solver: precision = parameter_precision                                        
%Value:                                                       
%pr_pen(parameter_alpha,L(matrix_F3_with_label1)-L(matrix_F3_with_label0))
%
%Input variables:
%
%Inputs                        PSG Type    PSG Object               Location in Problem Statement                                                      Class
%matrix_f3_benchmark           bench       matrix_f3                n/a                                                                                double
%matrix_f3_data                data        matrix_f3                n/a                                                                                double
%matrix_f3_vars                vars        matrix_f3                n/a                                                                                cell
%matrix_f3_with_label0_data    data        matrix_f3_with_label0    n/a                                                                                double
%matrix_f3_with_label0_vars    vars        matrix_f3_with_label0    n/a                                                                                cell
%matrix_f3_with_label1_data    data        matrix_f3_with_label1    n/a                                                                                double
%matrix_f3_with_label1_vars    vars        matrix_f3_with_label1    n/a                                                                                cell
%parameter_precision_data      data        parameter_precision      Solver: precision = parameter_precision                                            char
%parameter_alpha_data          data        parameter_alpha          pr_pen(parameter_alpha,L(matrix_F3_with_label1)-L(matrix_F3_with_label0))          double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


%Load data from mat-file:
load('D:\American Optimal Decisions\PSG\MATLAB_Stan\All\Classification in Loan Application Process\data_problem_2_2012\Optimization_subroutine_data.mat')

%Save variables from mat-file to Workspace:
tbpsg_export_to_workspace(toolboxstruc_arr)

%Run users m-function Optimization_subroutine:

[solution_str,outargstruc_arr] = Optimization_subroutine(matrix_f3_benchmark,matrix_f3_data,matrix_f3_vars,matrix_f3_with_label0_data,matrix_f3_with_label0_vars,matrix_f3_with_label1_data,matrix_f3_with_label1_vars,parameter_precision_data,parameter_alpha_data);

%Extract Objective:
val_obj = tbpsg_objective(solution_str, outargstruc_arr);

disp(' ');
disp('Objective = ');
disp(val_obj);

%Extract optimal solution:
point_data = tbpsg_optimal_point_data(solution_str, outargstruc_arr);

disp(' ');
disp('Optimal point = ');
disp(point_data);

%Extract structure containing PSG solution reports:
output_structure = tbpsg_solution_struct(solution_str, outargstruc_arr);

disp(' ');
disp('Structure with PSG solution = ');
disp(output_structure);

%Uncomment the following lines to extract solutions details:

%output = tbpsg_isoptimal(solution_str, outargstruc_arr);

%output = tbpsg_function_data(solution_str, outargstruc_arr);

%output = tbpsg_function_names(solution_str, outargstruc_arr);

%output = tbpsg_time(solution_str, outargstruc_arr);

%output = tbpsg_optimal_point_vars(solution_str, outargstruc_arr);

%output = tbpsg_constraints_vars(solution_str, outargstruc_arr);

%output = tbpsg_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_constraint_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_vars(solution_str, outargstruc_arr);

%output = tbpsg_vector_data(solution_str, outargstruc_arr);

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 
